%global	ruby_sitelib	%(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")
%global	ruby_sitearch	%(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")

%global	gemdir		%(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global	gemname	gtk2
%global	geminstdir	%{gemdir}/gems/%{gemname}-%{version}

%global	glibminver	0.90.5
%global	obsoleteevr	0.90.5-1.999

%global	rubyabi	1.8

Summary:	Ruby binding of GTK+-2.x
Name:		rubygem-%{gemname}
Version:	0.90.5
Release:	3%{?dist}
Group:		Development/Languages
# from README
License:	LGPLv2
URL:		http://ruby-gnome2.sourceforge.jp/
Source0:	http://rubygems.org/downloads/%{gemname}-%{version}.gem

BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	rubygems
BuildRequires:	rubygem-cairo-devel
BuildRequires:	rubygem-glib2-devel
BuildRequires:	rubygem-pango-devel
BuildRequires:	ruby-devel
BuildRequires:	gtk2-devel
Requires:	ruby(abi) = %{rubyabi}
Requires:	rubygems
Requires:	rubygem(atk) >= %{glibminver}
Requires:	rubygem(gdk_pixbuf2) >= %{glibminver}
Requires:	rubygem(glib2) >= %{glibminver}
Requires:	rubygem(pango) >= %{glibminver}
Provides:	rubygem(%{gemname}) = %{version}

%description
Ruby/GTK2 is a Ruby binding of GTK+-2.0.x.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%package	-n ruby-%{gemname}
Summary:	Non-Gem support package for %{gemname}
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
# Requires for corresponsing non-gem rpms
Requires:	ruby(atk) >= %{glibminver}
Requires:	ruby(gdk_pixbuf2) >= %{glibminver}
Requires:	ruby(glib2) >= %{glibminver}
Requires:	ruby(pango) >= %{glibminver}
Provides:	ruby(%{gemname}) = %{version}-%{release}

%description	-n ruby-%{gemname}
This package provides non-Gem support for %{gemname}.

%package	devel
Summary:	Ruby/GTK development environment
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
Requires:	ruby-devel
Requires:	gtk2-devel
Requires:	rubygem-glib2-devel
# Obsoletes / Provides
# ruby(%%{gemname}-devel) Provides is for compatibility
Obsoletes:	ruby-%{gemname}-devel < %{obsoleteevr}
Provides:	ruby-%{gemname}-devel = %{version}-%{release}
Provides:	ruby(%{gemname}-devel) = %{version}-%{release}

%description devel
Header files and libraries for building a extension library for the
rubygem-%{gemname}

%prep
%setup -q -c -T
mkdir -p .%{gemdir}

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
export CONFIGURE_ARGS="$CONFIGURE_ARGS --with-pkg-config-dir=$(pwd)%{_libdir}/pkgconfig"
gem install \
	-V \
	--local \
	--install-dir .%{gemdir} \
	--force \
	--rdoc \
	%{SOURCE0}

find . -name \*.gem | xargs chmod 0644

pushd .%{geminstdir}
# Fix wrong dir
grep -rl /usr/local/bin sample | \
	xargs sed -i -e 's|/usr/local/|/usr/|'

# Kill shebang
grep -rl '#!.*/usr/bin' sample lib | \
	xargs sed -i -e '\@#![ ]*/usr/bin@d'
find sample/ -name \*.rb | xargs chmod 0644
popd

%build
# Move C extension library to some private directory
pushd .%{geminstdir}
mkdir lib/ruby-gnome2
mv lib/%{gemname}.so lib/ruby-gnome2/
grep -rl '%{gemname}.so' . | \
	xargs sed -i \
		-e "\@require@s|'%{gemname}.so'|'ruby-gnome2/%{gemname}.so'|" \
		-e '\@require@s|"%{gemname}.so"|"ruby-gnome2/%{gemname}.so"|'

%install
rm -rf %{buildroot}

# Once copy all
mkdir -p %{buildroot}%{gemdir}
cp -a .%{gemdir}/* \
	%{buildroot}%{gemdir}/

pushd %{buildroot}
# move header files, C extension files to the correct directory
mkdir -p .%{ruby_sitearch}/ruby-gnome2
mv .%{geminstdir}/lib/*.h .%{ruby_sitearch}/
mv .%{geminstdir}/lib/ruby-gnome2/%{gemname}.so .%{ruby_sitearch}/ruby-gnome2/
popd

# move pkgconfig file
mkdir %{buildroot}%{_libdir}/pkgconfig
install -cpm 644 ./%{_libdir}/pkgconfig/*.pc \
	%{buildroot}%{_libdir}/pkgconfig/


# Cleanups
pushd %{buildroot}
rm -rf .%{geminstdir}/ext/
rm -f .%{geminstdir}/extconf.rb
popd

# The following method is completely copied from rubygem-gettext
# spec file
#
# Create symlinks
##
## Note that before switching to gem %%{ruby_sitelib}/%%{gemname}
## already existed as a directory, so this cannot be replaced
## by symlink (cpio fails)
## Similarly, all directories under %%{ruby_sitelib} cannot be
## replaced by symlink
#

create_symlink_rec(){

ORIGBASEDIR=$1
TARGETBASEDIR=$2

## First calculate relative path of ORIGBASEDIR 
## from TARGETBASEDIR
TMPDIR=$TARGETBASEDIR
BACKDIR=
DOWNDIR=
num=0
nnum=0
while true
do
	num=$((num+1))
	TMPDIR=$(echo $TMPDIR | sed -e 's|/[^/][^/]*$||')
	DOWNDIR=$(echo $ORIGBASEDIR | sed -e "s|^$TMPDIR||")
	if [ x$DOWNDIR != x$ORIGBASEDIR ]
	then
		nnum=0
		while [ $nnum -lt $num ]
		do
			BACKDIR="../$BACKDIR"
			nnum=$((nnum+1))
		done
		break
	fi
done

RELBASEDIR=$( echo $BACKDIR/$DOWNDIR | sed -e 's|//*|/|g' )

## Next actually create symlink
pushd %{buildroot}/$ORIGBASEDIR
find . -type f | while read f
do
	DIRNAME=$(dirname $f)
	BACK2DIR=$(echo $DIRNAME | sed -e 's|/[^/][^/]*|/..|g')
	mkdir -p %{buildroot}${TARGETBASEDIR}/$DIRNAME
	LNNAME=$(echo $BACK2DIR/$RELBASEDIR/$f | \
		sed -e 's|^\./||' | sed -e 's|//|/|g' | \
		sed -e 's|/\./|/|' )
	ln -s -f $LNNAME %{buildroot}${TARGETBASEDIR}/$f
done
popd

}

create_symlink_rec %{geminstdir}/lib %{ruby_sitelib}

%check
# X is needed, disabling.
# Note that some patches are needed under working X to make
# test suite success
exit 0

pushd .%{geminstdir}

# kill unneeded make process
rm -rf ./TMPBINDIR
mkdir ./TMPBINDIR
pushd ./TMPBINDIR
ln -sf /bin/true make
export PATH=$(pwd):$PATH
popd

ruby ./test/run-test.rb

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir	%{geminstdir}
%dir	%{geminstdir}/lib/
%dir	%{geminstdir}/lib/%{gemname}/

%doc	%{geminstdir}/[A-Z]*
%exclude	%{geminstdir}/Rakefile

%{geminstdir}/lib/%{gemname}.rb
%{geminstdir}/lib/%{gemname}/base.rb
# %%ruby_sitearch/ruby-gnome2 is owned by rubygem-glib2
%{ruby_sitearch}/ruby-gnome2/%{gemname}.so

%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%files	-n ruby-%{gemname}
%defattr(-,root,root,-)
%{ruby_sitelib}/*.rb
%{ruby_sitelib}/%{gemname}/

%files	devel
%defattr(-,root,root,-)
%{_libdir}/pkgconfig/ruby-%{gemname}.pc
%{ruby_sitearch}/rbgdk.h
%{ruby_sitearch}/rbgdkconversions.h
%{ruby_sitearch}/rbgtk.h
%{ruby_sitearch}/rbgtkconversions.h
%{ruby_sitearch}/rbgtkmacros.h

%files	doc
%defattr(-,root,root,-)
%{gemdir}/doc/%{gemname}-%{version}
%{geminstdir}/Rakefile
%{geminstdir}/sample/
%{geminstdir}/test/

%changelog
* Thu Nov 11 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.5-3
- Make ruby-gtk2 subpackage install corresponsing ruby- compat
  packages correctly (bug 652106)

* Sun Oct 31 2010 Mamoru Taska  <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.5-2
- 0.90.5
- Move C extension so that "require %%gemname" works correctly

* Sun Oct 24 2010 Mamoru Taska  <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.4-2
- 0.90.4

* Sun Oct 24 2010 Mamoru Taska  <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.3-2
- 0.90.3

* Fri Oct  1 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.2-3
- Initial package
